commit 09462375fbc19a2a71efee40dea16836f2d8295b
Author: freddy77 <freddy77>
Date:   Wed Aug 4 08:04:48 2010 +0000

    fix macro for odbc_set_sql_type_info

diff --git a/ChangeLog b/ChangeLog
index bbd7217..74ce2cd 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Aug  4 10:04:33 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc_util.c src/odbc/unittests/describecol.in:
+	- fix macro for odbc_set_sql_type_info
+
 Wed Aug  4 09:08:51 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/cs.c src/ctlib/ctutil.c:
 	- remove assumption CS_FAIL == TDS_FAIL and CS_SUCCEED ==
@@ -2813,4 +2817,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3107 2010/08/04 07:09:19 freddy77 Exp $
+$Id: ChangeLog,v 1.3108 2010/08/04 08:04:48 freddy77 Exp $
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 2f85969..440d5df 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.122 2010/08/04 06:55:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.123 2010/08/04 08:04:48 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -839,29 +839,31 @@ odbc_c_to_server_type(int c_type)
 void
 odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_ver)
 {
-#define SET_INFO(type, prefix, suffix) \
+#define SET_INFO(type, prefix, suffix) do { \
 	drec->sql_desc_literal_prefix = prefix; \
 	drec->sql_desc_literal_suffix = suffix; \
 	drec->sql_desc_type_name = type; \
-	return;
-#define SET_INFO2(type, prefix, suffix, len) \
+	return; \
+	} while(0)
+#define SET_INFO2(type, prefix, suffix, len) do { \
 	drec->sql_desc_length = len; \
-	SET_INFO(type, prefix, suffix)
+	SET_INFO(type, prefix, suffix); \
+	} while(0)
 
 	/* FIXME finish, support for N type (nvarchar) */
 	switch (tds_get_conversion_type(col->column_type, col->column_size)) {
 	case XSYBCHAR:
 	case SYBCHAR:
-		if (col->column_type == XSYBNCHAR)
+		if (col->on_server.column_type == XSYBNCHAR)
 			SET_INFO("nchar", "'", "'");
 		SET_INFO("char", "'", "'");
 	case XSYBVARCHAR:
 	case SYBVARCHAR:
-		if (col->column_type == SYBNVARCHAR || col->column_type == XSYBNVARCHAR)
+		if (col->on_server.column_type == SYBNVARCHAR || col->on_server.column_type == XSYBNVARCHAR)
 			SET_INFO("nvarchar", "'", "'");
 		SET_INFO("varchar", "'", "'");
 	case SYBTEXT:
-		if (col->column_type == SYBNTEXT)
+		if (col->on_server.column_type == SYBNTEXT)
 			SET_INFO("ntext", "'", "'");
 		SET_INFO("text", "'", "'");
 	case SYBBIT:
diff --git a/src/odbc/unittests/describecol.in b/src/odbc/unittests/describecol.in
index cf941ee..3d2ce37 100644
--- a/src/odbc/unittests/describecol.in
+++ b/src/odbc/unittests/describecol.in
@@ -144,6 +144,7 @@ attr SQL_DESC_OCTET_LENGTH 10
 attr SQL_DESC_PRECISION 10
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 10
+attr SQL_DESC_TYPE_NAME char
 
 select varchar(11) 'hi!'
 attr SQL_COLUMN_LENGTH 11
@@ -154,6 +155,7 @@ attr SQL_DESC_OCTET_LENGTH 11
 attr SQL_DESC_PRECISION 11
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 11
+attr SQL_DESC_TYPE_NAME varchar
 
 select nchar(12) 'hi!'+nchar(10)
 attr SQL_COLUMN_LENGTH 24
@@ -186,6 +188,7 @@ attr SQL_DESC_OCTET_LENGTH 4096
 attr SQL_DESC_PRECISION 4096
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 4096
+attr SQL_DESC_TYPE_NAME text
 
 select ntext 'hi!'
 attr SQL_COLUMN_LENGTH 4096

